% Evaluate the inverse function of the quantization function x^ga/(1-log(x^ga)) or (1-x)^ga/(1-log((1-x)^ga)).
% mode=1: x^ga/(1-log(x^ga)).
% mode=2: (1-x)^ga/(1-log((1-x)^ga)).

function ival = inv_prob_quant(val, ga, mode)

if ((val<=0)&(mode==1))
ival=0;
elseif ((val<=0)&(mode==2))
ival=1;
elseif ((val>=1)&(mode==1))
ival=1;
elseif ((val>=1)&(mode==2))
ival=0;

else

% Apply Newton method to calculate the inverse function.
ival=0.5; res=1e10;
while (res>0.001)

% Evaluate the derivative of f(x) for x=ival.
% mode=1: f(x)=x^ga+ga*ylog(x)-y.  df(x)=ga*x^(ga-1)+ga*y/x.  y=val.
% mode=2: f(x)=x^ga-ga*ylog(1-x)+y-1.  df(x)=ga*x^(ga-1)+ga*y/(1-x).  y=val.
% x(n+1)=x(n)-f(x(n))/df(x(n)).
x=ival; y=val;
if (mode==1)
f=x^ga+ga*y*log(x)-y; df=ga*x^(ga-1)+ga*y/x;
else
f=x^ga-ga*y*log(1-x)+y-1; df=ga*x^(ga-1)+ga*y/(1-x);
end
x2=x-f/df; res=abs(x2-ival); ival=x2;

% Stop when ival<=0 or ival>=1.
if (ival<=0)
ival=0; res=0;
elseif (ival>=1)
ival=1; res=0;
end

end

end

